package sk.lukasmacko.richfaces.demo;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;
import java.util.Random;
import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import sk.lukasmacko.richfaces.chart.component.event.DragStopEvent;
import sk.lukasmacko.richfaces.chart.component.model.ChartDataModel;
import sk.lukasmacko.richfaces.chart.component.model.StringChartModel;

/**
 *
 * @author Macko
 */
@ManagedBean
@SessionScoped
public class CompanyBean {

    
    private List<Departement> departements;
    private List<String> departementsName = new ArrayList<String>(
            Arrays.asList("X","Y","Z"));
    private Random generator;
    
    private StringChartModel incomeTotal;
    private StringChartModel expendureTotal;
    private SimpleDateFormat formatter;
    
    
    @PostConstruct
    public void init(){
        generator = new Random();
        formatter = new SimpleDateFormat("MM-yyyy");
        
        departements = new ArrayList<Departement>();
        for(int i=0;i<departementsName.size();i++){
            Departement d = new Departement(departementsName.get(i));
            this.addMonths(d);
            departements.add(d);
        }
        
        countTotal();
    }
    
    public void countTotal(){
        incomeTotal = new StringChartModel(ChartDataModel.ChartType.pie);
        expendureTotal = new StringChartModel(ChartDataModel.ChartType.pie);
        for(int i=0;i<departements.size();i++){
            double income=0;
            double expendure=0;
            for(int month=0;month<departements.get(i).getMonths().size();month++){
                income+=departements.get(i).getMonths().get(month).getIncome();
                expendure+=departements.get(i).getMonths().get(month).getExpendure();
            }
            incomeTotal.add(departements.get(i).getName(), income);
            expendureTotal.add(departements.get(i).getName(), expendure);

        }
    }
    
    public void addMonths(Departement d){
        for(int i=0;i<12;i++){
            Date date = new GregorianCalendar(2013, i, 1).getTime();
            d.addMonth(new Month(date,generator.nextInt(100),generator.nextInt(100)));
        }
        
    }

    public List<Departement> getDepartements() {
        return departements;
    }

    public StringChartModel getExpendureTotal() {
        return expendureTotal;
    }

    public StringChartModel getIncomeTotal() {
        return incomeTotal;
    }
    public String formatDate(Date d){
        return formatter.format(d);
    }
    
    public void changeIncome(DragStopEvent e){
        departements.get(e.getSeriesIndex())
                .getMonths().get(e.getPointIndex())
                .setIncome(e.getY().doubleValue());  
        countTotal();
    }
    
    public void changeExpendure(DragStopEvent e){
        departements.get(e.getSeriesIndex())
                .getMonths().get(e.getPointIndex())
                .setExpendure(e.getY().doubleValue());  
        countTotal();
    }
    
}
